PRO C_SCALE ,a,xtitle=xtitle,ytitle=ytitle,title=title,$
            max=max,min=min,top=top,bottom=bottom,portrait=portrait,$
             axis=axis, fill_color=fill_color,levels=levels,ticklen=ticklen,$
             xaxis = xaxis, yaxis = yaxis,c_colors=c_colors
;+
; NAME:
;	C_SCALE
; PURPOSE:
;	顼ʥ롦Сˤ̤˽Ϥ
; CATEGORY:
;	General graphics.
; CALLING SEQUENCE:
;	C_SCALE,A
; INPUTS:
;	A = 2 dimensional array to display.
; OPTIONAL INPUT PARAMETERS:
;	None.
; KEYWORD PARAMETERS:
;    for ANNONATIONS:
;       TITLE,XTITLE,YTITLE ꤵ줿ʸ plot, contour ʤɤǽ
;       ϤƱ֤˽Ϥ롣
;	TITLE   = 顼ΥȥʸͿ
;	          ǥե = ""
;	XTITLE  = 顼ΥȥʸͿ
;	          ǥե = ""
;	YTITLE  = 顼ΥȥʸͿ
;	          ǥե = ""
;
;    for SCALEING PARAMETERS:
;	MAX    = κǾ
;	         ǥե = MAX(A)
;	MIN    = κǾ
;	         ǥե = MIN(A)
;	TOP    = ѤƤ륫顼ǥåκ
;	         ǥե = MAX(!D.N_COLORS-1)
;	BOTTOM = ѤƤ륫顼ǥåκǾ
;	         ǥե = 0
;       /FILL_COLOR   = FILLed color
;       LEVELS  = If FILL_COLOR is set, this keywords is referred.
;       C_COLORS = The color index used to draw each contour
;
;    for GEOMETORY:
;       /PORTRAIT = ݡȥ쥤Ȥˤ롣ǥեȤ landscape
;        AXIS = If AXIS = 0, then Plot Data Window β() label 
;               If AXIS = 1, then Plot Data Window ξ() label 
;                /PORTRAIT 
;
;        TICKLEN = tick Ĺ
; EXAMPLE: 
;	tvcn ǲβ˥顼
;	erase    ;windowclear
;	beginp,[0.1,0.3,0.9,0.9],/norm      ; 
;	  tvcn,bytscl(rholc,max=6,min=0,top=189)+1b,rholc,rc,zc,/asp
;	endp
;	beginp,[0.1,0.15,0.9,0.2],/norm     ; 顼
;	  c_scale,rholc,max=6,min=0,top=190,bottom=1,xtitle='log_10(rho)'
;	endp
;	end
; OUTPUTS:
;	No explicit outputs.
; COMMON BLOCKS:
;	none.
; SIDE EFFECTS:
;	The currently selected display is affected.
; RESTRICTIONS:
;	顼ǥåѿ A ΣؿǤʤФʤʤ
; PROCEDURE:
;	If the device has scalable pixels then the image is written over
;	the plot window.
; MODIFICATION HISTORY:
;	T.Matsumoto 1994.9.7
;	T.Matsumoto 1995.1.20
;	T.Matsumoto 2000.8.23  bug fix for IDL5.3
;-
on_error,2
;;;;;; Define defaults values
if n_elements(title) eq 0 then title=''
if n_elements(xtitle) eq 0 then xtitle=''
if n_elements(ytitle) eq 0 then ytitle=''
if n_elements(max) eq 0 then max=max(a) 
if n_elements(min) eq 0 then min=min(a)
;if n_elements(top) eq 0 then top=!d.n_colors-1
if n_elements(top) eq 0 then top=!d.table_size-1
if n_elements(bottom) eq 0 then bottom=0
if n_elements(ticklen) eq 0 then ticklen = 0
if n_elements(axis) eq 0 then begin  ; backward compatibility
    if keyword_set(xaxis) then axis=1 else axis=0
    if keyword_set(yaxis) then axis=1 else axis=0
endif
if keyword_set(axis) then axis=1 else axis=0
;;;;;; save default system variables
xstyle_org=!x.style
ystyle_org=!y.style
!x.style=5    ;; axis range = exact. and suppress axis.
!y.style=5
;;;;; defun.  phys_v(0:top-bottom), range=[max,min]
phys_v=findgen(top-bottom+1)/float(top-bottom)*(max-min)+min

;;;; display color scale with no axis labels and no ticks
if keyword_set(fill_color) then begin ; fill colored
    if n_elements(levels) eq 0 then $
      levels = cont_level(phys_v,nlevel=10)
    if n_elements(c_colors) eq 0 then $
      c_colors = fix(findgen((size(levels))(1))/((size(levels))(1)-1) * (top-bottom))+bottom
    phys_a = [[phys_v],[phys_v]]
    cont=phys_a*0.0            ; dummy array for contour
    if not keyword_set(portrait) then begin
        cnvefill,phys_a,cont,cont,phys_v,[0,1],$
          levels=levels,yticks=1,ytickname=[' ',' '],$
          xticks=1,xtickname=[' ',' '],title=title,ytitle=ytitle,$
          limit = max(cont)+10,fill_colors=c_colors
    endif else begin
        cnvefill,rotate(phys_a,1),rotate(cont,1),rotate(cont,1),[0,1],phys_v,$
          levels=levels,xticks=1,xtickname=[' ',' '],$
          yticks=1,ytickname=[' ',' '],title=title,xtitle=xtitle,$
          limit = max(cont)+10,fill_colors=c_colors
    endelse

endif else begin                ; normal (pexel map)

    ; color index c_index(0:top-bottom) range=[bottom,top]
    c_index = bindgen(top-bottom+1)+byte(bottom)
    c_index=[[c_index],[c_index]]
    cont=c_index*0.0            ; dummy array for contour
    
    if n_elements(levels) eq 0 then levels=0
    if not keyword_set(portrait) then begin

        tvcn,c_index,cont,phys_v,[0,1],$
          levels=0,yticks=1,ytickname=[' ',' '],$
          xticks=1,xtickname=[' ',' '],title=title,ytitle=ytitle
    endif else begin

        tvcn,rotate(c_index,1),rotate(cont,1),[0,1],phys_v,$
          levels=0,xticks=1,xtickname=[' ',' '],$
          yticks=1,ytickname=[' ',' '],title=title,xtitle=xtitle

    endelse

endelse
;;;; draws axis labels
!x.style=1
!y.style=1
if keyword_set(portrait) then $
  axis,yaxis=axis,ytitle=ytitle,yticklen=ticklen $
  else axis,xaxis=axis,xtitle=xtitle,xticklen=ticklen


;;;;;; restore the  default system variables
!x.style=xstyle_org
!y.style=ystyle_org

return
end

