;+
; NAME:
;       ps1 
; PURPOSE:
;       device  "X""PS"ؤPostscript ե˲Ϥ롣
; ARGUMENTS:
;       None.
; CALLING SEQUENCE: 
;       PS1 [,keyword]
; KEYWORDS:
;       /LANDSCAPE   = if this keyword set, landscape oritentation is used.
;                       landscape ˤ롣
;
;       /COLOR       = for color image 
;                      顼κ˥åȤ롣Υ졼
;                      Ϥˤ⥻åȤۤɤ
;
;       /INTERPOLATE = interpolate color index to postscript
;                      "X"Υ顼ǥå"Postscript"Υ顼ǥ
;                      interpolation롣顼ǥåľ
;                      ꤷƺ褹ˤϤkeywordϥåȤʤ
;                      ɤ
;
;       FONT         = FONT Ǥޤ keyword ʸͿ
;                      ʤФʤʤǥեȤ Helvetica 
;                      㤨,FONT  Times ˻ꤹϡ
;                      font="Times " ޤ
;                      font="times"  keyword 򥻥åȤ롣
;                      ʸȾʸ̤ʤܤ, 
;                      table 򻲾ȤΤȡ
;
;      FONT_SIZE     = Same as the keyword for device procedure. See 
;                      "IDL Reference Guide". The default value is 12
;                      (point).
;      SCALE_FACTOR  = Same as the keyword for device procedure. See 
;                      "IDL Reference Guide". The default value is 1.
;      BITS_PER_PIXEL= Same as the keyword for device procedure. See 
;                      "IDL Reference Guide". This value should be
;                      1, 2, 4 and 8. These are corespond to 1, 2, 16
;                      and 256 posible colors. The default value is 4
;                      for black and white PostScript, and is 8 for
;                      color PostScript.
;      OUTPUT        = Same as the keyword for device procedure. See 
;                      "IDL Reference Guide".                        
;      /ENCAPSULATED = Same as the keyword for device procedure. See 
;                      "IDL Reference Guide".                        
;      /PREVIEW      = Same as the keyword for device procedure. See 
;                      "IDL Reference Guide".                        
;      XSIZE & YSIZE = Plot region 礭ꡣ keyword Ѥ
;                      ÷ XSIZE,YSIZE,XOFFSET,YOFFSET 
;                      ׵򤷤ʤʤ롣
;      XOFFSET & YOFFSET = Plot region  offset ͤꡣXSIZE  
;                      YSIE  keyword 򥻥åȤơ keyword 򥻥
;                      Ȥʤ,ǥեȤͤѤ롣
;      PSFILE        = Ϥ٤ PostScript file ̾*ʸ* 
;                      ǻꤹ롣 keyword 򥻥åȤ÷ 
;                      ϥե׵򤷤ʤʤ롣
;
;     Table : FONT KEYWORD        
;     =====================================================================
;         FONTS                         USAGE OF FONT KEYWORDS
;     ---------------------------------------------------------------------
;     Helvetica                     font = "Helvetica"                      
;     Helvetica-Narrow              font = "Helvetica,/Narrow"              
;     Times-Roman                   font = "Times"                   
;     Symbol                        font = "Symbol"                         
;     Courier                       font = "Courier"                        
;     Palatino-Roman                font = "Palatino"                
;     Palatino-Bold                 font = "Palatino,/Bold"                 
;     AvantGarde-Book               font = "Avantgarde,/Book"               
;     NewCenturySchlbk-Roman        font = "Schoolbook"         
;     NewCenturySchlbk-Bold         font = "Schoolbook,/Bold"         
;     Helvetica-Bold                font = "Helvetica,/Bold"                
;     Helvetica-Narrow-BoldOblique  font = "Helvetica,/Narrow,/Bold,/oblique" 
;     Times-BoldItalic              font = "Times,/Bold,/italic"              
;     ZapfDingbats                  font = "Zapfdingbats"                   
;     Courier-Oblique               font = "Courier,/Oblique"               
;     Palatino-Italic               font = "Palatino,/Italic"               
;     Palatino-BoldItalic           font = "Palatino,/Bold,/italic"           
;     ---------------------------------------------------------------------
;     嵭ʳ FONT  IDL Refarence Guide 3-29 table 3.11 򻲾
;     ΤȡFONT keyword λˡϾ嵭 table ˽सޤ
;
; EXAMPLE for usage:
;       IDL> ps1,font="Helvetica,/Narrow,/Bold,/oblique",/landscape
;       Input output file (defaults:idl.ps):test.ps
;       Do you specify the size of ploting space ? (y/n/l/usr:RET) :y
;       Input xsize,ysize ( unit : cm ) :20 10
;       Do you specify the offset of ploting space ? (y/n/usr:RET) :n
;       command ( device = PS ) > plot,[0,1]
;       command ( device = PS ) > ps2
;       Do you print out this plot ? (y/n) :y
;
; NOTE:
;       XSIZE, YSIZE  PLOT REGION 礭ꤹ롣޻ȡ
;       left margin  lower margin ϳơ xoffset, yoffset ǻꤹ롣
;
;
;                         _xsize               /LANDSCAPE                 
;                        /                                                
;                  +----/----+                     <--xsize-->            
;                  |  <--->  |                 +----------------+         
;                  |  +---+  |                 |   +---------+  |         
;                  |  |  ysize                 | ysize       |  |         
;                  |  |   |  |                 |   +---------+  |---      
;                  |  +---+  | -----           |                |  yoffset
;                  |         |  yoffset        +----------------+---      
;                  +---------+ -----           |   |                      
;                  |  |                        |xoffset                   
;                  |xoffset                                               
;
; ǥեͤ:
;
;      xsize, ysize, xoffset, yoffet ڤ font ϥ桼
;      ǥեͤꤹ뤳ȤǤޤ'~/idl/ps_profile'Ȥ
;      ե˥ǥեͤꤷޤ񼰤ϰʲ򻲾ȤƲ
;      ʲǤ xsize  ysize ơ 20cm  10 cm ˻ꤷ
;      ޤ
;
;      -------------- example of '~/idl/ps_profile' --------------
;      xsize = 20.0 ;; cm unit
;      ;xoffset= 1.5
;      ysize=10        
;      font=times,/bold,/italic
;
;      -------------- end of exapmple ---------------------------
;      ;ٰʹߤϥȤȤưޤ
;      ޤʸϹƬ񤫤ʤФʤޤ
;-
PRO ps1,landscape=landscape,color=color,interpolate=interpolate,font=font,$ 
        output=output,encapsulated=encapsulated,scale_factor=scale_factor,$ 
        font_size=font_size,preview=preview,bits_per_pixel=bits_per_pixel,$
        xsize=xsize,ysize=ysize,xoffset=xoffset,yoffset=yoffset,psfile=psfile
common common_ps,ofile,prompt_org,color_code,nocomline,direction,p_font
common paper_size,a4_x,a4_y
common pps, pxsize,pysize,pxoffset,pyoffset
on_error,2
if n_elements(xsize)*n_elements(ysize) ne 0 then nocomline=1 else $
  nocomline=0
;;; papaer size
a4_x=20.0
a4_y=a4_x*sqrt(2.0)
;;; specify parameter
ps_filename,psfile
ofile=psfile
ps_size_offset,xsize,ysize,xoffset,yoffset,landscape
;;;; default 
if n_elements(xsize) eq 0 then xsize=15.0
if n_elements(ysize) eq 0 then ysize=15.0
defaultfont="Helvetica"
rfile='~/idl/ps_profile'
;;;; evaluete the keywords
if keyword_set(landscape) then begin 
    keywd=",/landscape" 
    direction=1 
endif else begin
    keywd=",/portrait"
    direction=0
endelse
if n_elements(font) eq 0 then begin 
    ps_readfile,'font','~/idl/ps_profile',font,/string
    if n_elements(font) eq 0 then font=defaultfont
endif
keywd=keywd+",/"+font
if n_elements(output) ne 0 then keywd=keywd+",output="+output
if keyword_set(encapsulated) then keywd=keywd+",/encapsulated"
if n_elements(scale_factor) ne 0 then $
  keywd=keywd+",scale_factor="+STRING(FORMAT='(E12.5)',scale_factor)
if n_elements(font_size) ne 0 then $
  keywd=keywd+",font_size="+STRING(FORMAT='(E12.5)',font_size)
if keyword_set(preview) then keywd=keywd+",/preview"
if n_elements(bits_per_pixel) ne 0 then begin
    keywd=keywd+",bits_per_pixel="+STRING(FORMAT='(I2)',bits_per_pixel)
endif else begin 
    if keyword_set(color) then begin
        keywd=keywd+",bits_per_pixel=8"
    endif
endelse
;;;
p_font = !p.font
!p.font = 0
;;; device
if !d.name eq 'X' then prompt_org=!prompt
if keyword_set(color) then begin
    ps1_col,xsize,ysize,xoffset,yoffset,keywd,interpolate
    color_code=color
endif else begin
    ps1_mono,xsize,ysize,xoffset,yoffset,keywd
    color_code=0
endelse
;;; change prompt for Postscript device
if !d.name eq 'PS' then !prompt = 'command ( device = PS ) > '
pxsize=xsize
pysize=ysize
pxoffset=xoffset
pyoffset=yoffset
return
end

