; 
; tvcn2d.pro (Version 1, 2000/11/10)
;
; max output size 19.5 x 19.5, offset 0.5 x 4.4
;
; explanation for parameters (2002/06/28/ kana)
;   phys: parameter for color scale
;	t_max: maximum value for color scale
;	t_min: minimum value for color scale
;   physc: parameter for contour
;	c_lev, c2_lev: contour levels
;   sv1, sv2: parameters for arrows(sv1: x-comp., sv2: y-comp.)
;	j_skip, k_skip: the number of mesh points skipped in x-, y-direction 
;	v_scale: scale of arrows
;   
;
!p.font=1
!p.charsize=3
!x.thick=2.5
!y.thick=2.5
!z.thick=2.5
!p.thick=1.5
;
; array subscript
ixss=(ixe-ixs+1)/4
ixes=(ixe-ixs+1)*3/4
iyss=(iye-iys+1)/4
iyes=(iye-iys+1)*3/4
;
; array definition
case precision of
'FLOAT ': begin
;print,'data type: ',precision
xs = FLTARR(ixes-ixss+1)
ys = FLTARR(iyes-iyss+1)
rhos = FLTARR(ixes-ixss+1, iyes-iyss+1)
vxs = FLTARR(ixes-ixss+1, iyes-iyss+1)
vys = FLTARR(ixes-ixss+1, iyes-iyss+1)
bxs = FLTARR(ixes-ixss+1, iyes-iyss+1)
bys = FLTARR(ixes-ixss+1, iyes-iyss+1)
;
end
else: begin
;print,'data type: ',precision
xs = DBLARR(ixes-ixss+1)
ys = DBLARR(iyes-iyss+1)
rhos = DBLARR(ixes-ixss+1, iyes-iyss+1)
vxs = DBLARR(ixes-ixss+1, iyes-iyss+1)
vys = DBLARR(ixes-ixss+1, iyes-iyss+1)
bxs = DBLARR(ixes-ixss+1, iyes-iyss+1)
bys = DBLARR(ixes-ixss+1, iyes-iyss+1)
end
endcase
;
;substitution
for i=ixss,ixes do begin
	xs(i-ixss)= x(i)
endfor
;
for j=iyss,iyes do begin
	ys(j-iyss)= y(j)
endfor
;
for j=iyss,iyes do begin
	for i=ixss,ixes do begin
		rhos(i-ixss,j-iyss)=rho(i,j)
		vxs(i-ixss,j-iyss)=vx(i,j)
		vys(i-ixss,j-iyss)=vy(i,j)
		bxs(i-ixss,j-iyss)=bx(i,j)
		bys(i-ixss,j-iyss)=by(i,j)
	endfor
endfor
;
parameter='rhos'
parameter2='b'
;
phys=rhos
print,'Input "rho,vx,vy,bx,by,lrho,vt,bt,em,va" or "return"'
read,' for color scale,:',parameter
case parameter of
    'rho':phys=rhos
    'vx':phys=vxs
    'vy':phys=vys
    'bx':phys=bxs
    'by':phys=bys
    'lrho':phys=alog10(rhos)
    'vt':phys=sqrt(vxs^2+vys^2)
    'bt':phys=sqrt(bxs^2+bys^2+bzs^2)
    'em':phys=(bxs^2+bys^2+bzs^2)/(8*!pi)
    'va':phys=sqrt(bxs^2+bys^2+bzs^2)/(4*!pi*rhos)
    '':phys=physoldt
else:begin
    print,'"lrho" will be used!'
    phys=alog10(rhos)
    end
endcase
physoldt=phys
;
read,' for contour.:',parameter
case parameter of
    'rho':physc=rhos
    'vx':physc=vxs
    'vy':physc=vys
    'bx':physc=bxs
    'by':physc=bys
    'lrho':physc=alog10(rhos)
    'vt':physc=sqrt(vxs^2+vys^2)
    'bt':physc=sqrt(bxs^2+bys^2+bzs^2)
    'em':physc=(bxs^2+bys^2+bzs^2)/(8*!pi)
    'va':physc=sqrt(bxs^2+bys^2+bzs^2)/(4*!pi*rhos)
    '':physc=physoldc
else:begin
    print,'"lrho" will be used!'
    physc=alog10(rhos)
end
endcase
physoldc=physc
;
print,'Input "v" or "b"'
read,' for vector.:',parameter2
if (parameter2 eq "") then parameter2='v'
;
erase
;
; parameters for tv
t_max=max(phys)
t_min=min(phys)
;t_max=1.0
;t_min=0.5
;
; parameters for contour
;c_top=!d.n_colors
c_top=!d.table_size
c_lev=findgen(4)/4
c2_lev=findgen(16)/4-4
;c_lev=findgen(10)*0.05+0.5
;c2_lev=findgen(10)*0.05
;
; parameters for vector
i_skip=ixes/16
j_skip=iyes/16
;i_skip=ixes/25
;j_skip=iyes/25
;
; parameters for vector and axis
    print,'x-y slice'
    sphyst=phys
    sphysc=physc
    xax=xs
    yax=ys
    xtm='!16x!3'
    ytm='!16y!3' 
    case parameter2 of 
        'v':begin
            sv1=vxs
            sv2=vys
            end
        'b':begin
            sv1=bxs
            sv2=bys
            end
    endcase
;
v_scale=long(max(sqrt(sv1^2+sv2^2)))/((xs(1)-xs(0))*i_skip)
if (v_scale le 0.) then $
  v_scale=max(sqrt(sv1^2+sv2^2))/((xs(1)-xs(0))*i_skip) 
;v_scale=30.
;
beginp,[0.15,0.15,0.85,0.85]
tvcn2ve,$
bytscl(phys,top=c_top-3,max=t_max,min=t_min)+1,$
physc,sv1,sv2,physc,xax,yax,/asp,xtitle=xtm,ytitle=ytm,$
;iskip=i_skip,jskip=j_skip,v_col=!d.n_colors,scale=v_scale,$
iskip=i_skip,jskip=j_skip,v_col=-1,scale=v_scale,$
levels=c_lev,c_col=1,$
l2evels=c2_lev,c2_col=0
endp
;
; parameters for title
stime=STRING(FORMAT='(F5.2)',timei)
xyouts,-max(xs)*0.2,max(ys)*1.05,/data,'!8t!3 ='+stime
;
; the size of unit arrow
v0=5.0
arrow,max(xs)*0.6,max(ys)*1.10,max(xs)*0.6+(v0/v_scale),max(ys)*1.10,/data,hsize=30.*v0/v_scale
xyouts,max(xs)*0.65+(v0/v_scale),max(ys)*1.09,'!8v=1.0 v!D0!N!3',/data
;
beginp,[0.85,0.15,0.87,0.85]
c_scale,sphyst,top=c_top-3+1,max=t_max,min=t_min,bottom=1,/portrait,yaxis=1
endp
;
end