; 
; tvcn2d.pro (Version 1, 2000/11/10)
;
; max output size 19.5 x 19.5, offset 0.5 x 4.4
;
; explanation for parameters (2002/06/28/ kana)
;   phys: parameter for color scale
;	t_max: maximum value for color scale
;	t_min: minimum value for color scale
;   physc: parameter for contour
;	c_lev, c2_lev: contour levels
;   sv1, sv2: parameters for arrows(sv1: x-comp., sv2: y-comp.)
;	j_skip, k_skip: the number of mesh points skipped in x-, y-direction 
;	v_scale: scale of arrows
;
; Output filename and size
ps1,/col,/in,psfile='test2.eps',xsize=12.7,ysize=12.7
;
!p.font=0.
!p.charsize=1.6
!x.thick=1.2
!y.thick=1.2
!z.thick=1.2
!p.thick=1.0
;
parameter='rho'
parameter2='b'
;
phys=rho
print,'Input "rho,vx,vy,bx,by,lrho,vt,bt,em,va" or "return"'
read,' for color scale,:',parameter
case parameter of
    'rho':phys=rho
    'vx':phys=vx
    'vy':phys=vy
    'bx':phys=bx
    'by':phys=by
    'lrho':phys=alog10(rho)
    'vt':phys=sqrt(vx^2+vy^2)
    'bt':phys=sqrt(bx^2+by^2+bz^2)
    'em':phys=(bx^2+by^2+bz^2)/(8*!pi)
    'va':phys=sqrt(bx^2+by^2+bz^2)/(4*!pi*rho)
    '':phys=physoldt
else:begin
    print,'"lrho" will be used!'
    phys=alog10(rho)
    end
endcase
physoldt=phys
;
read,' for contour.:',parameter
case parameter of
    'rho':physc=rho
    'vx':physc=vx
    'vy':physc=vy
    'bx':physc=bx
    'by':physc=by
    'lrho':physc=alog10(rho)
    'vt':physc=sqrt(vx^2+vy^2)
    'bt':physc=sqrt(bx^2+by^2)
    'em':physc=(bx^2+by^2)/(8*!pi)
    'va':physc=sqrt(bx^2+by^2+bz^2)/(4*!pi*rho)
    '':physc=physoldc
else:begin
    print,'"lrho" will be used!'
    physc=alog10(rho)
end
endcase
physoldc=physc
;
print,'Input "v" or "b"'
read,' for vector.:',parameter2
if (parameter2 eq "") then parameter2='v'
;
erase
;
; parameters for tv
t_max=max(phys)
t_min=min(phys)
;
; parameters for contour
;c_top=!d.n_colors
c_top=!d.table_size
c_lev=findgen(4)/4
c2_lev=findgen(16)/4-4
;c_lev=findgen(10)*0.05+0.5
;c2_lev=findgen(5)*0.1
;
; parameters for vector
i_skip=ixe/16
j_skip=iye/16
;
; parameters for vector and axis
    print,'x-y slice'
    sphyst=phys
    sphysc=physc
    xax=x
    yax=y
    xtm='!16x!3'
    ytm='!16y!3' 
    case parameter2 of 
        'v':begin
            sv1=vx
            sv2=vy
            end
        'b':begin
            sv1=bx
            sv2=by
            end
    endcase
;
v_scale=long(max(sqrt(sv1^2+sv2^2)))/((x(1)-x(0))*i_skip)
if (v_scale le 0.) then $
  v_scale=max(sqrt(sv1^2+sv2^2))/((x(1)-x(0))*i_skip) 
;
beginp,[0.15,0.15,0.85,0.85]
tvcn2ve,$
bytscl(phys,top=c_top-3,max=t_max,min=t_min)+1,$
physc,sv1,sv2,physc,xax,yax,/asp,xtitle=xtm,ytitle=ytm,$
;iskip=i_skip,jskip=j_skip,v_col=!d.n_colors,scale=v_scale,$
iskip=i_skip,jskip=j_skip,v_col=-1,scale=v_scale,$
levels=c_lev,c_col=1,$
l2evels=c2_lev,c2_col=0
endp
;
; parameters for title
stime=STRING(FORMAT='(F5.2)',timei)
xyouts,-max(x)*0.2,max(y)*1.05,/data,'!8t!3 ='+stime
;
; the size of unit arrow
v0=5.0
arrow,max(x)*0.6,max(y)*1.10,max(x)*0.6+(v0/v_scale),max(y)*1.10,/data,hsize=30.*v0/v_scale
xyouts,max(x)*0.65+(v0/v_scale),max(y)*1.09,'!8v=1.0 v!D0!N!3',/data
;
beginp,[0.85,0.15,0.87,0.85]
c_scale,sphyst,top=c_top-3+1,max=t_max,min=t_min,bottom=1,/portrait,yaxis=1
endp
;
ps2,/no
end